<div class="row">
        <div class="col-md-2"></div>
        <div class="col-md-8">
            <div class="row">
                <div class="col">
                    <div class="alert alert-box" role="alert">
                        <h3>Riclassificazione Voce Daco</h3>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col">
                    <app-alert></app-alert>
                </div>
            </div>
            <form #insertFormRef="ngForm" name="myForm" (ngSubmit)="onSubmit()">
                <div class="row">
                    <div class="col">
                        <div class="row">
                            <div class="col">
                                <div class="form-group">
                                    <label class=" font-weight-bold">Data Inserimento: </label>
                                    <input type="text" class="form-control form-control-sm" [(ngModel)]="model._insertDate"
                                        name="insertDate" bsDatepicker
                                        [bsConfig]="{ dateInputFormat: 'DD/MM/YYYY', containerClass: 'theme-default' , showWeekNumbers : false}"
                                        [bsValue]="model._insertDate" disabled required  #insertDateRef="ngModel">
                                        <div *ngIf="(insertDateRef.invalid && (insertDateRef.dirty || insertDateRef.touched))" class="validation-messages">
                                            <div *ngIf="insertDateRef.errors.required; then requiredErr else invalidErr"></div>
                                            <ng-template #requiredErr>Campo obbligatorio e nel formato dd/mm/yyyy</ng-template>
                                            <ng-template #invalidErr>{{insertDateRef.errors.error}}</ng-template>
                                        </div>
                                </div>
                            </div>
                            <div class="col">
                                <div class="form-group" 
                                    [ngClass]="{'has-error' : (competenceDateRef.invalid && (competenceDateRef.dirty || competenceDateRef.touched))}">
                                    <label class=" font-weight-bold">Data Competenza: </label>
                                    <input type="text" autocomplete="off" class="form-control form-control-sm"
                                        [(ngModel)]="model._competenceDate" name="competenceDate" bsDatepicker
                                        [bsConfig]="{ dateInputFormat: 'DD/MM/YYYY', containerClass: 'theme-default', showWeekNumbers : false }"
                                        [bsValue]="model._competenceDate" [maxDate]="competenceDateUpperBound()" required placeholder="gg/mm/aaaa"
                                        #competenceDateRef="ngModel">
                                    <div *ngIf="(competenceDateRef.invalid && (competenceDateRef.dirty || competenceDateRef.touched))"
                                        class="validation-messages">
                                        <div  *ngIf="competenceDateRef.errors.required; then requiredErr else invalidErr">
                                        </div>
                                        <ng-template #requiredErr>Campo obbligatorio </ng-template>
                                        <ng-template #invalidErr>{{competenceDateRef.errors.error}}</ng-template>
                                    </div>
                                </div>
                            </div>
                            <div class="col"></div>
                        </div>
                    </div>
                </div>
                <hr>
                <div class="row">
                    <div class="col">
                        <div class="form-group">
                            <label class=" font-weight-bold">Filiale:</label>
                            <div class="form-group">
                                <ng-select
                                    [ngClass]="{'has-errorSelect' : (BranchRef.invalid && (BranchRef.dirty || BranchRef.touched))}"
                                    [items]="branchOptions" name="branch" style="width: 100%" bindLabel="full"
                                    placeholder="Seleziona Filiale" notFoundText="Nessun Risultato"
                                    (change)="selectionBranchChanged($event)" [(ngModel)]="model.branch"
                                    #BranchRef="ngModel" required>
                                </ng-select>
                            <div *ngIf="BranchRef.errors && (BranchRef.dirty || BranchRef.touched)"
                                class="validation-messagesSelect">
                                <div [hidden]="!BranchRef.errors.required">
                                    <div *ngIf="BranchRef.errors.required; then requiredErr else invalidErr"></div>
                                    <ng-template #requiredErr>Seleziona una Filiale</ng-template>
                                    <ng-template #invalidErr>{{BranchRef.errors.error}}</ng-template>
                                </div>
                            </div>
                            </div>
                        </div>
                    </div>
                    <div class="col">
                        <div class="form-group"
                            [ngClass]="{'has-error' : (frazionarioRef.invalid && (frazionarioRef.dirty || frazionarioRef.touched))}">
                            <label class="font-weight-bold">Frazionario Up: </label>
                            <input type="text" class="form-control " placeholder="Inserisci un Frazionario"
                                name="fractional" (change)="fractionalChanged($event)" [(ngModel)]="model.fractional"
                                required maxlength="20" #frazionarioRef="ngModel">
                            <div *ngIf="(frazionarioRef.invalid && (frazionarioRef.dirty || frazionarioRef.touched))"
                                class="validation-messages">
                                <div *ngIf="frazionarioRef.errors.required; then requiredErr else invalidErr"> </div>
                                <ng-template #requiredErr>Campo Obbligatorio</ng-template>
                                <ng-template #invalidErr>{{frazionarioRef.errors.error}}</ng-template>
                            </div>
                        </div>
                    </div>
                    
                    <div class="col">
                        <div class="row1">
                            <div class="cola">
                                <label class="font-weight-bold">Denominazione Up:</label>
                            </div>
                            <div class="cola">
                                <div class="form-group">
    
                                    <ng-select
                                        [ngClass]="{'has-errorSelect' : (OfficeRef.invalid && (OfficeRef.dirty || OfficeRef.touched))}"
                                        [items]="model.branch?.office" name="office" style="width: 100%"
                                        [disabled]="model.branch == null ||  model.branch.office?.length == 0 "
                                        bindLabel="fractionalDescription" placeholder="Seleziona Denominazione"
                                        notFoundText="Nessun Risultato" (change)="selectionOfficeChanged($event)"
                                        [(ngModel)]="model.office" #OfficeRef="ngModel" required>
                                    </ng-select>
                                <div *ngIf="OfficeRef.errors && (OfficeRef.dirty || OfficeRef.touched)"
                                    class="validation-messagesSelect">
                                    <div *ngIf="OfficeRef.errors.required; then requiredErr else invalidErr"></div>
                                    <ng-template #requiredErr>Seleziona un Ufficio</ng-template>
                                    <ng-template #invalidErr>{{OfficeRef.errors.error}}</ng-template>
                                </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <hr>
                <div class="row">
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Voce
                                Daco: </label>
                            <div class="form-group">
                                <ng-select
                                    [ngClass]="{'has-errorSelect' : (dacoRef.invalid && (dacoRef.dirty || dacoRef.touched))}"
                                    [items]="dacoListSource" name="daco" style="width: 100%"
                                    (change)="selectionDacoChanged($event, model); filterDacoOnchange(true);" bindLabel="full"
                                    placeholder="Seleziona Daco" notFoundText="Nessun Risultato" [(ngModel)]="model.daco"
                                    #dacoRef="ngModel" required>
                                </ng-select>
                            <div *ngIf="dacoRef.errors && (dacoRef.dirty || dacoRef.touched)"
                                class="validation-messagesSelect">
                                <div *ngIf="dacoRef.errors.required; then requiredErr else invalidErr"></div>
                                <ng-template #requiredErr> Seleziona una voce Daco</ng-template>
                                <ng-template #invalidErr>{{dacoRef.errors.error}}</ng-template>
                            </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Servizio: </label>
                            <div class="input-group form-group ">
                                <ng-select [items]="model.daco?.services" name="service" style="width: 100%"
                                    bindLabel="full" placeholder="Seleziona Servizio"
                                    [disabled]="model.daco == null || model.daco.services?.length==0 "
                                    notFoundText="Nessun Risultato" [(ngModel)]="model.service" #serviceRef="ngModel"
                                    required  #serviceRef="ngModel">
                                </ng-select>
                                <div *ngIf="(serviceRef.invalid && (serviceRef.dirty || serviceRef.touched))" class="validation-messagesSelect">
                                        <div *ngIf="serviceRef.errors.required; then requiredErr else invalidErr"> </div>
                                         <ng-template #requiredErr>Campo Obbligatorio</ng-template>
                                         <ng-template #invalidErr>{{serviceRef.errors.error}}</ng-template>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col">
                      
                        <label class="font-weight-bold">AVERE (AUMENTA)</label>
                                <div class="form-group"
                                    [ngClass]="{'has-error' : (creditAmountRef.invalid && (creditAmountRef.dirty || creditAmountRef.touched))}">
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <div class="input-group-text"><strong>€</strong></div>
                                        </div>
                                        <input type="text" autocomplete="off" class="form-control "
                                            [(ngModel)]="model.creditAmount" name="creditAmount"
                                            placeholder="Inserisci un importo" (keypress)="cleanAmount(true)"
                                            (keydown)="checkAmountDigit($event); switchLabel(); " pattern="^[0-9]{1,}([.][0-9]{1,2})?$"
                                            min="0" (change)="cleanAmount(true); checkValidAmount(false);"
                                            onPaste="cleanAmount(true)" #creditAmountRef="ngModel" maxlength="14">

                                    </div>
                                    <div *ngIf="(creditAmountRef.invalid && (creditAmountRef.dirty || creditAmountRef.touched))" class="validation-messages">
                                     <div *ngIf="creditAmountRef.errors.required; then requiredErr else invalidErr"> </div>
                                     <ng-template #requiredErr>Campo obbligatorio e di tipo numerico</ng-template>
                                     <ng-template #invalidErr>{{creditAmountRef.errors.error}}</ng-template>
                                    </div>
                                </div>
                            
                        
                    </div>
                    <div class="col">
                        <label class="font-weight-bold">DARE (DIMINUISCE)</label>
                                <div class="form-group"
                                    [ngClass]="{'has-error' : (debitAmountRef.invalid && (debitAmountRef.dirty || debitAmountRef.touched))}">
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <div class="input-group-text"><strong>€</strong></div>
                                        </div>                                   
                                        <input maxlength="14" type="text" autocomplete="off" class="form-control "
                                            [(ngModel)]="model.debitAmount" name="debitAmount"
                                            placeholder="Inserisci un importo" pattern="^[0-9]{1,}([.][0-9]{1,2})?$" min="0"
                                            (keypress)="cleanAmount(false); " (keydown)="switchLabel();checkAmountDigit($event)"
                                            (change)="cleanAmount(false); checkValidAmount(true);" onPaste="cleanAmount(false);"
                                            #debitAmountRef="ngModel">
                                    </div>
                                    <div *ngIf="(debitAmountRef.invalid && (debitAmountRef.dirty || debitAmountRef.touched))"
                                    class="validation-messages">
                                    <div *ngIf="debitAmountRef.errors.required; then requiredErr else invalidErr"> </div>
                                    <ng-template #requiredErr>Campo obbligatorio e di tipo numerico</ng-template>
                                    <ng-template #invalidErr>{{debitAmountRef.errors.error}}</ng-template>
                               
                            </div>
                        </div>
                    </div>
                    <!--div class="col">
                        <!--div class="form-group"
                            [ngClass]="{'has-error' : (codContabileRef.invalid && (codContabileRef.dirty || codContabileRef.touched))}">
                            <label class="font-weight-bold">Cocont: </label>
                            <input type="text" class="form-control " name="accountNumber" (change)="accountNumberChanged(dacoListSource, model,'accountNumber');"
                                placeholder="" [(ngModel)]="model.accountNumber" required
                                maxlength="20" #codContabileRef="ngModel" disabled>
                            <div *ngIf="(codContabileRef.invalid && (codContabileRef.dirty || codContabileRef.touched))"
                                class="validation-messages">
                                <div *ngIf="codContabileRef.errors.required; then requiredErr else invalidErr"> </div>
                                <ng-template #requiredErr>Campo Obbligatorio</ng-template>
                                <ng-template #invalidErr>Codice Contabile non valido</ng-template>
    
                            </div>
                        </div-->
                    <!--/div-->
                </div>
                <div class="row">
                        <div class="col">
                            <div class="form-group">
                                <label class="font-weight-bold">Allinea Forma
                                    Tecnica: </label>
                                <div class="form-group">
                                    <ng-select
                                        [ngClass]="{'has-errorSelect' : (evalGeneratedDacoRef.invalid && (evalGeneratedDacoRef.dirty || evalGeneratedDacoRef.touched))}"
                                        [items]="dacoListGenerated" name="generated.daco" style="width: 100%"
                                        (change)="selectionDacoChanged($event, evalGenerated); filterDacoOnchange(false);" bindLabel="full"
                                        placeholder="Seleziona Daco" notFoundText="Nessun Risultato" [(ngModel)]="evalGenerated.daco"
                                        #evalGeneratedDacoRef="ngModel" >
                                    </ng-select>
                                    <div *ngIf="(evalGeneratedDacoRef.invalid && (evalGeneratedDacoRef.dirty || evalGeneratedDacoRef.touched))" class="validation-messagesSelect">
                                    <div *ngIf="evalGeneratedDacoRef.errors.required; then requiredErr else invalidErr"> </div>
                                    <ng-template #requiredErr>Campo Obbligatorio</ng-template>
                                    <ng-template #invalidErr>{{evalGeneratedDacoRef.errors.error}}</ng-template>    
                                </div>
                                </div>
                            </div>
                        </div>
                        <div class="col">
                            <div class="form-group">
                                <label class="font-weight-bold">Servizio: </label>
                                <div class="input-group form-group ">
                                    <ng-select [items]="evalGenerated.daco?.services" name="serviceAlign" style="width: 100%"
                                        bindLabel="full" placeholder="Seleziona Servizio"
                                        [disabled]="evalGenerated.daco == null || evalGenerated.daco.services?.length==0 "
                                        notFoundText="Nessun Risultato" [(ngModel)]="evalGenerated.service" #serviceAlignRef="ngModel"
                                        required  #serviceAlignRef="ngModel">
                                    </ng-select>
                                    <div *ngIf="(serviceAlignRef.invalid && (serviceAlignRef.dirty || serviceAlignRef.touched))" class="validation-messagesSelect">
                                            <div *ngIf="serviceAlignRef.errors.required; then requiredErr else invalidErr"> </div>
                                             <ng-template #requiredErr>Campo Obbligatorio</ng-template>
                                             <ng-template #invalidErr>{{serviceRef.errors.error}}</ng-template>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col">
                            <div style="height: 31px;" [hidden]="(model.debitAmount && !model.creditAmount)||(!model.debitAmount && model.creditAmount)"></div>
                            <label #dynLabel class="font-weight-bold" [hidden]="!model.debitAmount && !model.creditAmount">{{dynamicLabel}}</label>
                            <div class="form-group" >
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <div class="input-group-text"><strong>€</strong></div>
                                        </div>
                                        <input type="text" autocomplete="off" class="form-control "
                                            [ngModel]="model.creditAmount?model.creditAmount:model.debitAmount" disabled name="Amount"
                                         #amountRef="ngModel" >

                                    </div>
                                    
                                </div>
                        </div>
                        <div class="col">
                            <label style="margin-top:20px"> </label>
                            <div class="form-group ">
                                <button type="button" class="btn btn-primary btn-sm"
                                    (click)="openAttachmentsModal(AttachmentComponet)">Allegati
                                    ({{model.attachments.length + attachmentToUpload.length}})</button>
                            </div>
                        </div>
                    </div>
                <hr>
                <div class="row">
                    
                    
                </div>
                <div class="row">
                    <div class="col">
                        <div class="form-group"
                            [ngClass]="{'has-error' : (descriptionRef.invalid && (descriptionRef.dirty || descriptionRef.touched))}">
                            <label class="font-weight-bold">Descrizione: </label>
                            <div class="form-group">
                                <textarea #descriptionRef="ngModel"  class="form-control "
                                    [(ngModel)]="model.description" maxlength="600" name="description" rows="3" required>
                                </textarea>
                                <div *ngIf="descriptionRef.errors && (descriptionRef.dirty || descriptionRef.touched)"
                                    class="validation-messages">
                                    <div *ngIf="descriptionRef.errors.required; then requiredErr else invalidErr"></div>
                                    <ng-template #requiredErr>Campo obbligatorio</ng-template>
                                    <ng-template #invalidErr>{{descriptionRef.errors.error}}</ng-template>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <hr>
                <div class="row">
                    <div class="col">
                    <button type="button" class="btn btn-sm btn-danger size buttonCancel" 
                        (click)="goToHome()">Annulla</button>
                    <button type="submit" [disabled]="!(insertFormRef.valid && (model.debitAmount > 0 || model.creditAmount >0 ))"
                    class="btn btn-sm btn-success size buttonConfirm">Conferma</button>
                </div> 
            </div>
                    
            </form>
            <hr>
            <div class="row">
                    <div class="col" style="width: 100%; display: inline-block">
                        <table datatable [dtOptions]="dtOptions" [dtTrigger]="dtTrigger" class="row-border hover centered-datatables" id="dailyReclassification">
                            <thead>
                              
                            </thead>
                        </table>
                    </div>
            </div>
        </div>
        <div class="col-md-2">
    
        </div>
    </div>
  
    <br>
   <ng-template #AttachmentComponet>
            <app-attachment [evaluation-id]="model.id" [attachments]="attachmentToUpload"  [modalRef]="modalRef" (update)="getFiles($event)"></app-attachment>
    </ng-template>
    